# Using GConf

The information in this chapter describes how to use GConf to manage user preferences.

## Introduction to GConf

GConf simplifies the administration of preferences for GNOME Desktop users. GConf enables system administrators to do the following:

- Set mandatory values for particular preferences for all users. In this way, system administrators can control whether users can update particular preferences.

- Set default values for particular preferences for all users.

- Use suggested values for preferences that are specified in definition files for the preferences.

- Read documentation on each preference.

GConf also notifies applications when a preference value changes, locally or across a network. In this way, when you change a preference, all applications that use the preference are immediately updated.

GConf has the following components:

- A repository of user preferences.

- A daemon, `gconfd-2`.

- A command line tool, `gconftool-2`.

## GConf Repository

Each preference in the GConf repository is expressed as a key-value pair. A GConf preference key is an element in the repository that corresponds to an application preference. For example, the /apps/gnome-session/options/show_splash_screen preference key corresponds to the Show splash screen on login option in the Sessions preference tool. The GNOME Desktop user interface does not contain all of the preference keys in the GConf repository. For example, the Panel preference tool does not contain an option that corresponds to the /apps/panel/global/tooltips_enabled key.

The repository is structured like a simple hierarchical file system. The repository contains the following:

- Directories that correspond to applications that use the GConf repository. For example, the file system contains the directory /apps/metacity.

- Subdirectories that correspond to categories of preferences. For example, the file system contains the directory /apps/metacity/general.

- Special files that list the preference keys in the directory, and contain information about the keys. For example, a file that contains information about the keys that relate to the HTTP proxy preferences is in the directory /system/http_proxy.

- A /schemas directory that contains files that describe all of the preference keys.

Preference keys typically have simple values such as strings, integers, or lists of strings and integers. The format of the preference key in the repository depends on the backend module that is used to read the repository. The following is an example of the /desktop/gnome/interface/font_name preference key when an Extensible Markup Language (XML) backend module is used to read the repository:

    <entry name="font_name" mtime="1038323555" muser="user123" type="string">
    <stringvalue>Sans 10</stringvalue></entry>

When this guide refers to a preference key, the path to the key is added to the name of the key. For example, the font_name preference key in the /desktop/gnome/interface subdirectory is referred to as /desktop/gnome/interface/font_name.

### GConf Configuration Sources

The GConf repository contains a series of storage locations that are called configuration sources. The configuration sources are listed in the GConf path file. The location of the GConf path file is /etc/gconf/gconf-version-number/path. Each user has a path file. The path file specifies the following information for each configuration source:

- The backend module to use to read the repository.

- The permissions on the repository.

- The location of the repository.

The GConf path file also contains include instructions. By default, the contents of the GConf path file are as follows:

    xml:readonly:/etc/gconf/gconf.xml.mandatory
    include /etc/gconf/2/local-mandatory.path
    include "$(HOME)/.gconf.path"
    include /etc/gconf/2/local-defaults.path
    xml:readwrite:$(HOME)/.gconf
    xml:readonly:/etc/gconf/gconf.xml.defaults

When GConf searches for a preference value, GConf reads the configuration sources in the order specified in the path file. The following table describes the configuration sources in the path file:

Configuration Source | Description
--- | ---
Mandatory | The permissions on this configuration source are set to read only. Users cannot overwrite the values in this source, so the preferences in the source are mandatory.
User | This configuration source is stored in the `.gconf` directory in the home directory of the user. When the user sets a preference, the new preference information is added to this location. You can use the Configuration Editor to modify the user configuration source.
Default | This configuration source contains the default preference settings.

The sequence of the configuration sources in the path file ensures that mandatory preference settings override user preference settings. The sequence also ensures that user preference settings override default preference settings. That is, GConf applies preferences in the following order of priority:

1. Mandatory preferences

2. User-specified preferences

3. Default preferences

The include instructions in the GConf path file enable system administrators to specify other configuration sources.

Included Configuration Source | Description
--- | ---
`/etc/gconf/2/local-mandatory.path` | Use this configuration source to store mandatory preference values for a particular system.
`$(HOME)/.gconf.path` | The user specifies the location of the configuration source in the home directory, in a file that is called `.gconf.path`.
`/etc/gconf/2/local-defaults.path` | Use this configuration source to store default preference values for a particular system.

### GConf Schemas

A GConf schema is a collective term for a GConf schema key and a GConf schema object. The following table describes schema keys and schema objects and the relationship of these items to preference keys:

Item | Description
--- | ---
Preference key | An element in the GConf repository that corresponds to an application preference.
Schema key | A key that stores a schema object for a preference key.

Schema object

An element in a configuration source that contains information for a preference key, such as the following:

- The name of the application that uses the preference key.

- The type of value required for the preference key, for example integer, boolean, and so on.

- A default value for the preference key.

- Brief documentation on the preference key.

The following table gives examples of a preference key, a schema key, and a schema object:

Item | Example
--- | ---
Preference key | /desktop/gnome/interface/font_name
Schema key | /schemas/desktop/gnome/interface/font_name

Schema object

    <schema>
      <applyto>/desktop/gnome/interface/font_name</applyto>
      <key>/schemas/desktop/gnome/interface/font_name</key>
      <owner>gnome</owner>
      <type>string</type>
      <default>Sans 10</default>
      <locale name="C">
        <short>Default font</short>
          <long>Name of the default font used by gtk+.</long>
      </locale>
    </schema>

You can associate a schema key with a preference key. For example, the following /desktop/gnome/interface/font_name key includes a schema key:

    <entry name="font_name" mtime="1034873859"
    schema="/schemas/desktop/gnome/interface/font_name"/>

When you associate a schema key with a preference key, the preference uses the suggested value that is specified in the schema object of the schema key. The suggested value is contained in the `<default>` element in the schema object. By default, all the preference keys in the default configuration source are associated with schema keys.

Typically, schemas are stored in the default configuration source.

### GConf Schema Definition Files

Schemas are generated from schema definition files. A schema definition file defines the characteristics of all of the keys in a particular application. Schema definition files have a `.schemas` extension.

The schema definition files are included in the `/etc/gconf/schemas` directory. You can use the schema definition files to create a new configuration source.

Some schema definition files correspond closely to a part of the GNOME Desktop user interface. For example, `system_http_proxy.schemas` corresponds to the Network Proxy preference tool. Other schema definition files contain preference keys that are not present in the GNOME Desktop user interface. For example, the /apps/panel/global/tooltips_enabled key is not present in the user interface.

Some parts of the GNOME Desktop user interface contain preferences that represent preference keys from more than one schema definition file. For example, the Keyboard Shortcuts preference tool contains preferences that represent keys from the `panel-global-config.schemas` and `metacity.schemas` files.

## GConf Daemon

The GConf daemon is called `gconfd-2`. The GConf daemon notifies applications when a preference value changes. For example, you might select to show only icons in toolbars in the Menus & Toolbars preference tool. When you select this option in the preference tool, the toolbars on all open applications are updated instantly. The GConf daemon can operate locally, or across a network.

An instance of the GConf daemon is started for each user. The GConf daemon does not have to deal with complex problems such as authentication and data security. When the GConf daemon starts, the daemon loads the GConf path file. The GConf daemon manages all access between applications and the configuration sources.

When an application requests the value of a preference key, the daemon searches the configuration sources as follows:

1. Search for the value of the preference key in each configuration source, in the order specified in the path file. If the value is found, return the value.

2. If a value is not found, search for the schema key that corresponds to the preference key in each configuration source, in the order specified in the path file.

3. If the schema key is found, check the value of the schema key.

4. If the value of the schema key is a schema object, return the suggested value in the `<default>` element of the schema object.

The GConf daemon also caches preference key values. All applications use this cache, so applications only need to access the configuration sources once.

To terminate the GConf daemon, run the following command:

    gconftool-2 --shutdown

## GConf Command Line Tool

GConf includes a command line tool, `gconftool-2`. You can use the `gconftool-2` command to perform the following tasks:

- Set the values of keys.

- Display the values of keys.

- Install schemas from schema definition files when you install an application.

For example, use the following command to display the values of all keys in the /desktop/gnome directory and subdirectories.

    gconftool-2 --recursive-list /desktop/gnome

Below are listed some of the options that you can use with the `gconftool-2` command. For detailed command line options, please see man:gconftool-2(1).

### gconftool-2 Command Options

`--all-dirs`

  Lists all subdirectories in a directory that you specify.

`--all-entries`

  Displays the values of all keys in a directory that you specify.

`--config-source=configuration-source`

  Use this option with the `--direct` option to specify a configuration source to use. If you do not specify a configuration source with this option, the command runs on all configuration sources in the path file.

`--direct`

  Use this option with the `--config-source` option to access a configuration source directly. When you use this option, GConf bypasses the server. Ensure that the GConf daemon, `gconfd-2`, is not running before you use this option.

`--dump`

  Generates a list that contains all preference keys in a GConf repository directory that you specify. The list contains XML descriptions of all the keys. The list is contained in a `<gconfentryfile>` element.

  For example, you can redirect the output from this option to generate a file that lists all keys that are related to your panel configuration. You can use the `--load` option with this file.

`--get`

  Displays the value of a preference key that you specify. Also displays the values of the elements in the schema object for a schema key that you specify.

`--help`

  Displays a help message about the `gconftool-2` command, and the options that you can use with the `gconftool-2` command.

`--load=filename`

  Use this option to sets the values of preference keys in the current directory in a configuration source to the values in the file that you specify. The file that you specify must contain XML descriptions of the keys, in a `<gconfentryfile>` element.

`--long-desc=description`

  Use this option with the `--set-schema` option to specify a long description for a schema key.

`--makefile-install-rule`

  Installs schema definition files to applications.

`--owner=owner`

  Use this option with the `--set-schema` option to specify an owner for a schema key.

`--recursive-list`

  Displays the values of all preference keys in all subdirectories in a directory that you specify.

`--recursive-unset`

  Resets the values of all preference keys, in all subdirectories in a directory, from the user setting to the setting in the default configuration source.

`--set`

  Sets the value of a preference key, and writes the value to the user configuration source. Use the `--type` option with the `--set` option to specify the data type of the value that you want to set. For example, the following command sets the value of the /apps/gnome-terminal/profiles/Default/background_color key in the user configuration source:

      gconftool-2 \
        --set "/apps/gnome-terminal/profiles/Default/background_color" \
        --type string "#000000"

  You can also use the `--direct` option and the `--config-source` option with the `--set` option to write a value to another configuration source.

`--set-schema`

  Sets the value of an attribute in a schema key, and writes the value to the default configuration source.

  Use the following options with the `--set-schema` option to specify the attribute that you want to update:

  - `--type`

  - `--short-desc`

  - `--long-desc`

  - `--owner`

  For example, the following command sets the short description in the schema key for the /apps/gnome-terminal/profiles/Default/background_color key:

      gconftool-2 \
        --set-schema  "/schemas/apps/gnome-terminal/profiles/Default/background_color" \
        --short-desc "Default  background color of terminal"

`--short-desc=description`

  Use this option with the `--set-schema` option to specify a short description for a schema key.

`--shutdown`

  Terminates the GConf daemon.

`--type=data-type`

  Use this option to specify the data type when you set a value of a preference key. You can also use this option when you set the value of an attribute in a schema key. The following is a list of valid data types:

  - bool

  - float

  - int

  - list

  - pair

  - string

`--unset`

  Resets the value of a preference key from the user setting to the setting in the default configuration source.

`--usage`

  Displays a brief help message about the `gconftool-2` command, and the options that you can use with the `gconftool-2` command.

## To Set Preference Values

You can set a mandatory value or a default value for a preference key. Before you change mandatory preference values or default preference values for users, you must ensure that the GConf daemon is not running for any user. Ensure that all users are logged out before you change preference values for users.

To set a mandatory value or a default value for a preference key, use the `gconftool-2` command, as follows:

    gconftool-2 --direct \
      --config-source configuration-source \
      --type data-type \
      --set preference-key value

For example, to set `wwwproxy.xyz.com` as the mandatory HTTP proxy host, run the following command:

    gconftool-2 --direct \
      --config-source xml:readwrite:/etc/gconf/gconf.xml.mandatory \
      --type string \
      --set /system/http_proxy/host wwwproxy.xyz.com

The user cannot override this preference value.

You can also use the `gconftool-2` command to set default values. For example, to set the default number of workspaces to five, run the following command:

    gconftool-2 --direct \
      --config-source xml:readwrite:/etc/gconf/gconf.xml.defaults \
      --type int \
      --set /apps/metacity/general/num_workspaces 5

The user can override this preference value.

Before you change mandatory preference values or default preference values for users, you must ensure that all users are logged out.

## Setting General Preferences

The following sections describe how to assign mandatory or default values to general preferences.

### To Set HTTP Proxy Preferences

To set HTTP proxy preferences, you modify the values of the preference keys in the /system/http_proxy/ location. For example, to set a mandatory value for the HTTP proxy host, run the following command:

    gconftool-2 --direct \
      --config-source xml:readwrite:/etc/gconf/gconf.xml.mandatory \
      --type string \
      --set /system/http_proxy/host proxy-name

To set a default value for the HTTP proxy host, run the following command:

    gconftool-2 --direct \
      --config-source xml:readwrite:/etc/gconf/gconf.xml.defaults \
      --type string \
      --set /system/http_proxy/host proxy-name

You can also set other HTTP proxy-related preferences. For information on the other HTTP proxy preferences, see the `system_http_proxy.schemas` schema definition file.

### To Set Print Manager Preferences

To set print manager preferences, you modify the values of the preference keys in the /apps/gnome-print-manager location. For example, if you do not want users to view the print jobs of other users, set a mandatory value as follows:

    gconftool-2 --direct \
      --config-source xml:readwrite:/etc/gconf/gconf.xml.mandatory \
      --type bool \
      --set /apps/gnome-print-manager/show_all_jobs false

To set a default value for this preference, run the following command:

    gconftool-2 --direct \
      --config-source xml:readwrite:/etc/gconf/gconf.xml.defaults \
      --type bool \
      --set /apps/gnome-print-manager/show_all_jobs false

You can also set other print manager preferences. For information on the other print manager preferences, see the `gnome-print-manager.schemas` schema definition file.

### To Set the Number of Workspaces

To set a mandatory number of workspaces, use the following command:

    gconftool-2 --direct \
      --config-source xml:readwrite:/etc/gconf/gconf.xml.mandatory \
      --type int \
      --set /apps/metacity/general/num_workspaces integer

To set a default number of workspaces, use the following command:

    gconftool-2 --direct \
      --config-source xml:readwrite:/etc/gconf/gconf.xml.defaults \
      --type int \
      --set /apps/metacity/general/num_workspaces integer

You can also set other window manager preferences. For information on the other window manager preferences, see the `metacity.schemas` schema definition file.

### To Set Keyboard Accessibility Preferences

To set keyboard accessibility preferences, you modify the values of the preference keys in the /desktop/gnome/accessibility/keyboard location. For example, if you want to set a mandatory value so that keyboard accessibility features are enabled, run the following command:

    gconftool-2 --direct \
      --config-source xml:readwrite:/etc/gconf/gconf.xml.mandatory \
      --type bool \
      --set /desktop/gnome/accessibility/keyboard/enable true

To set a default value for this preference, run the following command:

    gconftool-2 --direct \
      --config-source xml:readwrite:/etc/gconf/gconf.xml.defaults \
      --type bool \
      --set /desktop/gnome/accessibility/keyboard/enable false

You can also set other keyboard accessibility preferences. For information on the other keyboard accessibility preferences, see the `desktop_gnome_accessibility_keyboard.schemas` schema definition file.

### To Set Keyboard Shortcut Preferences

To set keyboard shortcut preferences, you modify the values of preference keys in /apps/metacity/global_keybindings location. For example, you might want users to use only the AltF3 keyboard shortcut to open the Run Application dialog. To set this mandatory value, run the following command:

    gconftool-2 --direct \
      --config-source xml:readwrite:/etc/gconf/gconf.xml.mandatory \
      --type string \
      --set /apps/metacity/global_keybindings/panel_run_dialog '<Alt>F3'

You can also set other keyboard shortcut preferences. For information on the other keyboard shortcut preferences, see the `metacity.schemas` schema definition file.

### Setting Panel and Panel Object Preferences

The `panel-default-setup.entries` file specifies the following details of the panels in the GNOME Desktop:

- Number of panels.

- Types of the panels.

- Properties of the panels.

- Contents of the panels.

The configuration of individual panels and of panel objects is a complex task. To configure individual panels and panel objects, you must first understand the structure of the `panel-default-setup.entries` file. For more information on the `panel-default-setup.entries` file, see the next section.

To set preferences for individual panels and panel objects, you must set the values of many preferences in a configuration source. The easiest way to set the values of panel preferences is to use the `gconftool-2` command with the `--dump` and `--load` options. For more information on how to set preferences for panels and objects on panels, see .

#### Specifying Individual Panels and Panel Objects

The file `panel-default-setup.entries` contains sections that specify panels and panel contents. The `panel-default-setup.entries` file specifies values for schema keys. The `panel-default-setup.entries` file resides in the `/etc/gconf/schemas` directory.

The `panel-default-setup.entries` file is structured as follows:

1. Keys that specify the general structure of panels, applets, and other panel objects in the GNOME Desktop. The following keys specify the number of panels, panel objects, and applets that appear in the GNOME Desktop:

   - /apps/panel/default_setup/general/toplevel_id_list

   - /apps/panel/default_setup/general/object_id_list

   - /apps/panel/default_setup/general/applet_id_list

   The keys also assign identifiers to each panel, panel object, and applet. For example, the following sample from `panel-default-setup.entries` specifies that one panel appears in the GNOME Desktop:

       <entry>
         <key>toplevel_id_list</key>
         <schema_key>/schemas/apps/panel/general/toplevel_id_list</schema_key>
         <value>
           <list type="string">
             <value>
               <string>bottom_panel</string>
             </value>
           </list>
         </value>
       </entry>

   In the `panel-default-setup.entries` file, the identifier bottom_panel identifies the bottom edge panel.

2. Keys that specify the properties of the panels. The panel property keys are structured as follows:

       /apps/panel/default_setup/toplevels/panel-name/panel-property-key

   For example, the key /apps/panel/default_setup/toplevels/bottom_panel/size specifies the size of the bottom panel.

3. Keys that specify the panel objects, the panel object properties, and the panels in which the objects reside. For example, the following sample from `panel-default-setup.entries` specifies a Main Menu object at the left side of the bottom panel:

       <entrylist base="/apps/panel/default_setup/objects/main_menu">
         <entry>
           <key>object_type</key>
           <schema_key>/schemas/apps/panel/objects/object_type</schema_key>
           <value>
             <string>menu-object</string>
           </value>
         </entry>
         <entry>
           <key>toplevel_id</key>
           <schema_key>/schemas/apps/panel/objects/toplevel_id</schema_key>
           <value>
             <string>bottom_panel</string>
           </value>
         </entry>
         <entry>
           <key>position</key>
           <schema_key>/schemas/apps/panel/objects/position</schema_key>
           <value>
             <int>0</int>
           </value>
         </entry>
         <!-- Possibly more entry elements -->
       </entrylist>

4. Keys that specify the applets, the applet preferences, and the panels in which the applets reside. For example, the following sample from `panel-default-setup.entries` specifies the Window List applet, in the bottom panel:

       <entrylist base="/apps/panel/default_setup/applets/window_list">
         <entry>
           <key>object_type</key>
           <schema_key>/schemas/apps/panel/objects/object_type</schema_key>
           <value>
             <string>bonobo-applet</string>
           </value>
         </entry>
         <entry>
           <key>toplevel_id</key>
           <schema_key>/schemas/apps/panel/objects/toplevel_id</schema_key>
           <value>
             <string>bottom_panel</string>
           </value>
         </entry>
         <entry>
           <key>position</key>
           <schema_key>/schemas/apps/panel/objects/position</schema_key>
           <value>
             <int>2</int>
           </value>
         </entry>
         <!-- Possibly more entry elements -->
         <entry>
           <key>bonobo_iid</key>
           <schema_key>/schemas/apps/panel/objects/bonobo_iid_type</schema_key>
           <value>
             <string>OAFIID:GNOME_WindowListApplet</string>
           </value>
         </entry>
       </entrylist>

   The OAFIID is a unique identifier for an applet. To find the OAFIID for a particular applet, see the `.server` file for the applet in the `/usr/lib/bonobo/servers` directory. For example, the following excerpt from `GNOME_Wncklet_Factory.server` shows the OAFIID for the Window List applet:

       <oaf_server iid="OAFIID:GNOME_WindowListApplet"
       type="factory" location="OAFIID:GNOME_Wncklet_Factory">

#### To Set Preferences for Individual Panels and Panel Objects

To set the preferences for a panel and the objects on a panel perform the following steps:

1. Log in to a GNOME session, and configure the panels as required.

2. Use the `--dump` option with the `gconftool-2` command line tool to generate a file that contains an XML description of your panel configuration. The `--dump` option generates a list that contains all preference keys in a GConf repository directory that you specify.

   For example, the following command creates an XML description of the default panel configuration in a file called `my-panel-setup.entries`:

       gconftool-2 --dump /apps/panel > my-panel-setup.entries

3. Open the `my-panel-setup.entries` file in a text editor, and modify the file as required.

   For example, you might want to change the location of the desktop entry files. The following is an excerpt from a file generated with the `--dump` option:

       <entry>
         <key>objects/object_16/launcher_location</key>
         <schema_key>/schemas/apps/panel/objects/launcher_location</schema_key>
         <value>
           <string>hadjaha-00adce02f7.desktop</string>
         </value>
       </entry>

   In the sample above, you might want to change the reference to `hadjaha-00adce02f7.desktop` to another desktop entry file that is available globally.

   When you generate a panel configuration with the `--dump` option, the positions of the panel objects are absolute positions. You might want to change the positions of panel objects from absolute positions to relative positions. The object at the extreme left of a panel has a position value of `0`. The next object has a position value of `1`, and so on. If you want object positions to be relative to the right side of the panel, set the value of the right_stick key to `true`.

4. Use the `--load` option with the `gconftool-2` command line tool to set the values of the default configuration source to the values in the `my-panel-setup.entries` file. For example, the following command sets the values of the keys in the default configuration source to the values of the corresponding keys in `my-panel-setup.entries`:

       gconftool-2 --direct \
         --config-source xml:readwrite:/etc/gconf/gconf.xml.defaults \
         --load my-panel-setup.entries

## Setting Look-and-Feel Preferences

The following sections describe how to assign mandatory or default values to look-and-feel preferences.

### To Set Font Preferences

To set font preferences, you modify the values of two preference keys. The following table shows the keys to modify, and the part of the user interface to which the keys correspond:

GConf Location | User Interface Component
--- | ---
/desktop/gnome/interface/font_name | Font preference tool, Application font option
/apps/nautilus/preferences/desktop_font | Font preference tool, Desktop font option

For example, to set `Sans 12` as the mandatory application font, run the following command:

    gconftool-2 --direct \
      --config-source xml:readwrite:/etc/gconf/gconf.xml.mandatory \
      --type string \
      --set /desktop/gnome/interface/font_name "Sans 12"

To set `palatino 12` as the default desktop object font, run the following command:

    gconftool-2 --direct \
      --config-source xml:readwrite:/etc/gconf/gconf.xml.defaults \
      --type string \
      --set /apps/nautilus/preferences/desktop_font "palatino 12"

### To Set Background Preferences

To set preferences for the desktop background, you modify the values of the preference keys in the /desktop/gnome/background location. For example, to set a mandatory image for the background, run the following command:

    gconftool-2 --direct \
      --config-source xml:readwrite:/etc/gconf/gconf.xml.mandatory \
      --type string \
      --set /desktop/gnome/background/picture_filename filename.png

To set a default value for this preference, run the following command:

    gconftool-2 --direct \
      --config-source xml:readwrite:/etc/gconf/gconf.xml.defaults \
      --type string \
      --set /desktop/gnome/background/picture_filename filename.png

You can also set other background preferences. For information on the other background preferences, see the `desktop_gnome_background.schemas` schema definition file.

### To Set Splash Image Preferences

To set splash image preferences, you modify the value of the preference keys in the /apps/gnome-session/options/ location. For example, if you do not want users ever to see a splash image, set a mandatory value as follows:

    gconftool-2 --direct \
      --config-source xml:readwrite:/etc/gconf/gconf.xml.mandatory \
      --type bool \
      --set /apps/gnome-session/options/show_splash_screen false

To set a default value for this preference, run the following command:

    gconftool-2 --direct \
      --config-source xml:readwrite:/etc/gconf/gconf.xml.defaults \
      --type bool \
      --set /apps/gnome-session/options/show_splash_screen false

You can also set other splash image preferences. For information on the other splash image preferences, see the `gnome-session.schemas` schema definition file.

## To Restore Default Preference Values

To restore the default preference values for a user, run the following command:

    gconftool-2 --direct \
      --config-source user-configuration-source \
      --recursive-unset

Replace user-configuration-source with the configuration source in the `.gconf` directory in the home directory of the user.

This command resets the values of all preference keys, in all subdirectories, from the user setting to the setting in the default configuration source.